summaryrefslogtreecommitdiffstats
path: root/libraries/PLUMED
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/PLUMED')
-rw-r--r--libraries/PLUMED/PLUMED.SlackBuild146
-rw-r--r--libraries/PLUMED/PLUMED.info10
-rw-r--r--libraries/PLUMED/README23
-rw-r--r--libraries/PLUMED/slack-desc19
4 files changed, 198 insertions, 0 deletions
diff --git a/libraries/PLUMED/PLUMED.SlackBuild b/libraries/PLUMED/PLUMED.SlackBuild
new file mode 100644
index 0000000000..3b00227bee
--- /dev/null
+++ b/libraries/PLUMED/PLUMED.SlackBuild
@@ -0,0 +1,146 @@
+#!/bin/bash
+
+# Slackware build script for PLUMED
+
+# Copyright 2022 William PC - Seattle, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=PLUMED
+VERSION=${VERSION:-2.8.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf plumed2-$VERSION
+tar xvf $CWD/plumed2-$VERSION.tar.gz
+cd plumed2-$VERSION
+
+# remove symlink to avoid error at find
+# File system loop detected.
+rm src/include/plumed
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+
+# by default it detects a MPI installation
+# the OMP version explicity disable the MPI
+# then the else condition forces the default
+# slackbuild execution to build the serial PLUMED
+if [ "${OMP:-no}" == "yes" ]; then
+ OPT_BUILD="--enable-openmp --disable-mpi"
+elif [ "${MPI:-no}" == "yes" ]; then
+ OPT_BUILD="--enable-mpi --disable-openmp"
+elif [ "${HYBRID:-no}" == "yes" ]; then
+ OPT_BUILD="--enable-openmp --enable-mpi"
+else
+ OPT_BUILD="--disable-openmp --disable-mpi"
+fi
+
+if [ "${PYTHON:-no}" == "yes" ]; then
+ OPT_BUILD="$OPT_BUILD --enable-python"
+ export PYTHON_BIN="python3"
+fi
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --htmldir=/usr/doc/$PRGNAM-$VERSION \
+ --pdfdir=/usr/doc/$PRGNAM-$VERSION \
+ --enable-shared \
+ --enable-fftw \
+ $OPT_BUILD \
+ --build=$ARCH-slackware-linux
+
+make
+make -C vim
+make install DESTDIR=$PKG
+
+if [ "${DOC:-no}" == "yes" ]; then
+ make doc
+ cp -av developer-doc $PKG/usr/doc/$PRGNAM-$VERSION
+ cp -av user-doc $PKG/usr/doc/$PRGNAM-$VERSION
+fi
+
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ COPYING.LESSER PEOPLE VERSION \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/PLUMED/PLUMED.info b/libraries/PLUMED/PLUMED.info
new file mode 100644
index 0000000000..2d04d630af
--- /dev/null
+++ b/libraries/PLUMED/PLUMED.info
@@ -0,0 +1,10 @@
+PRGNAM="PLUMED"
+VERSION="2.8.0"
+HOMEPAGE="https://www.plumed.org"
+DOWNLOAD="https://github.com/plumed/plumed2/archive/v2.8.0/plumed2-2.8.0.tar.gz"
+MD5SUM="ad6032b5f2e47726bda1fc855865f26f"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="William PC"
+EMAIL="w_calandrini[at]hotmail[dot]com"
diff --git a/libraries/PLUMED/README b/libraries/PLUMED/README
new file mode 100644
index 0000000000..bb9322ced6
--- /dev/null
+++ b/libraries/PLUMED/README
@@ -0,0 +1,23 @@
+ PLUMED is an open-source, community-developed library that provides
+a wide range of different methods, which include:
+ - enhanced-sampling algorithms
+ - free-energy methods
+ - tools to analyze the vast amounts of data produced by molecular
+ dynamics (MD) simulations.
+
+ These techniques can be used in combination with a large toolbox
+of collective variables that describe complex processes in physics,
+chemistry, material science, and biology.
+
+
+ By default PLUMED is compiled in serial mode, if you want to
+enable parallel mode set one of the following variables:
+ - OMP=yes, for enable OpenMP
+ - MPI=yes, for enable MPI (requires mpich or openmpi)
+ - HYBRID=yes, OpenMP+MPI (requires mpich or openmpi)
+
+ For building support for python set PYTHON=yes.
+
+If you want to install the documentation set DOC=yes
+
+ * Optional dependences: blas and lapack (shall improve performance)
diff --git a/libraries/PLUMED/slack-desc b/libraries/PLUMED/slack-desc
new file mode 100644
index 0000000000..2124395cd7
--- /dev/null
+++ b/libraries/PLUMED/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+PLUMED: PLUMED (PLUgin for MolEcular Dynamics)
+PLUMED:
+PLUMED:
+PLUMED: PLUMED is an open-source, community-developed library that provides
+PLUMED: a wide range of different methods, which include:
+PLUMED: - enhanced-sampling algorithms
+PLUMED: - free-energy methods
+PLUMED: - tools to analyze the vast amounts of data produced by molecular
+PLUMED: dynamics (MD) simulations.
+PLUMED:
+PLUMED: